#include </lib/std.mi>

// Declare local functions for use in script
Function setVolumeAnim(int volValue);
Function updateVolume(int x, int y);

// Declare global variables for use in script
Global AnimatedLayer Volume;
Global Map VolumeMap;
Global Text SongTicker;
Global Timer SongTickerTimer;
Global Boolean VolumeChanging;
Global Layout parent;
Global Button vol0, vol10, vol70, vol150, vol255;

// When the script/skin is loaded, do this
System.onScriptLoaded() {
	Group ScriptGrp = getScriptGroup();

	// Get Volume Layer and SongTicker
	Volume = ScriptGrp.findObject("VolumeAnim");
	parent = ScriptGrp.getParentLayout();
	vol0=ScriptGrp.findObject("volume0");
	vol10=ScriptGrp.findObject("volume10");
	vol70=ScriptGrp.findObject("volume70");
	vol150=ScriptGrp.findObject("volume150");
	vol255=ScriptGrp.findObject("volume255");
	

	// Initialize Maps
	VolumeMap = new Map;
	VolumeMap.loadMap("player.map.Volume");

	//Set Initial Volume Setting
	setVolumeAnim(System.getVolume());
}

parent.onStartup()
{
	SongTicker = parent.findObject("SongTicker");

	// Initialize our timer
	SongTickerTimer = new Timer;
	SongTickerTimer.setDelay(750);
}

// Clears text area
SongTickerTimer.onTimer() {
	SongTicker.setText("");
	SongTickertimer.stop();
}

// Updates display and SongTicker on Volume changes
System.onVolumeChanged(int newVol) {
	setVolumeAnim(newVol);
	Songtickertimer.stop();
	Songtickertimer.start();
	int p = (newVol * 100) / 255;
	Songticker.setAlternateText("Volume:" + System.integerToString(p) + "%)");
}

//sets the Animation to correct frame
setVolumeAnim(int Value) {
	int f = (Value * (Volume.getLength()-1)) / 255;
    if (Value > 0) {
		Volume.gotoFrame(f+1);
	}
	if (Value == 255) {
		Volume.gotoFrame(f);
	}
	if (Value == 0) {
		Volume.gotoFrame(0);
	}
}

// Handles Volume Mouse Events
vol0.onLeftButtonDown(int x, int y) {

	System.setVolume(0);
}

vol10.onLeftButtonDown(int x, int y) {

	System.setVolume(10);
}

vol70.onLeftButtonDown(int x, int y) {

	System.setVolume(70);
}

vol150.onLeftButtonDown(int x, int y) {

	System.setVolume(150);
}

vol255.onLeftButtonDown(int x, int y) {

	System.setVolume(255);
}

System.onScriptUnloading() {
	delete SongTickerTimer;
	delete VolumeMap;
}